﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Example.xaml
    /// </summary>
    public partial class Example : Window
    {
        public Example()
        {
            InitializeComponent();
            this.DataContext = new TimelineViewModel();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var vm = this.DataContext as TimelineViewModel;
            vm.UpdateViewModel();
        }
    }

    class TimelineViewModel : ViewModelBase
    {
        public DateTime PeriodStart { get; set; }
        public DateTime PeriodEnd { get; set; }

        private ITimelineItem itemWithDuration;

        private List<ITimelineItem> timelineItems;
        public List<ITimelineItem> Data
        {
            get { return timelineItems; }
            set { timelineItems = value; }
        }

        public TimelineViewModel()
        {
            this.PeriodStart = new DateTime(2015, 4, 20);
            this.PeriodEnd = this.PeriodStart.AddYears(2);

            this.itemWithDuration = new ItemWithDuration() { Date = this.PeriodStart.AddMonths(3), Duration = TimeSpan.FromDays(210) };

            this.timelineItems = new List<ITimelineItem>()
            {
                this.itemWithDuration
            };            
        }

        public void UpdateViewModel()
        {
            this.itemWithDuration.Duration = GetNewTimeSpan();
        }

        private TimeSpan GetNewTimeSpan()
        {
            return itemWithDuration.Duration.Add(TimeSpan.FromDays(60));
        }
    }

    public class ItemWithDuration : ViewModelBase, ITimelineItem
    {
        public DateTime Date { get; set; }

        private TimeSpan duration;
        public TimeSpan Duration
        {
            get
            {
                return this.duration;
            }
            set
            {
                if (this.duration != value)
                {
                    this.duration = value;
                    OnPropertyChanged("Duration");
                }
            }
        }
    }

    public interface ITimelineItem
    {
        DateTime Date { get; set; }
        TimeSpan Duration { get; set; }
    }
}
